#include "defines.h"
#include "serial.h"
#include "lib.h"
#include "register.h"
#include "pll.h"

/* CPUν 1Ƥ */
static void cpu_init(void)
{
  /* 
   * I/O쥸˥WAIT
   * 0x00: WAIT̵
   * 0x01: WAITͭ
   */
  V850ES_JG2_VSWC = 0x01;

  /*
   * åץǥХå
   * 0x00: Ѥʤ
   * 0x01: Ѥ
   */
  V850ES_JG2_OCDM = 0x00;

  /*
   * åɥåޤ
   * 0x00 : Ѥʤ
   * other: Ѥ
   */
  V850ES_JG2_WDTM2 = 0x00;

  /*
   * ¢ȯ
   * åɥåޤѤʤȤȯʤ
   * 0x00: ȯ
   * 0x01: ȯʤ
   */
  V850ES_JG2_RCM = 0x01;
}

static int init(void)
{
  /* ʲϥ󥫡ץȤƤ륷ܥ */
  extern int erodata, data_start, edata, bss_start, ebss;

  /* CPU Ϣν */
  cpu_init();
  pll_init();

  /*
   * ǡΰBSSΰ롥νʹߤǤʤȡ
   * ХѿƤʤΤա
   */
  memcpy(&data_start, &erodata, (long)&edata - (long)&data_start);
  memset(&bss_start, 0, (long)&ebss - (long)&bss_start);

  /* ꥢν */
  serial_init(SERIAL_DEFAULT_DEVICE);

  return 0;
}

int global_data = 0x10;
int global_bss;
static int static_data = 0x20;
static int static_bss;

static void printval(void)
{
  puts("global_data = "); putxval(global_data, 0); puts("\n");
  puts("global_bss  = "); putxval(global_bss,  0); puts("\n");
  puts("static_data = "); putxval(static_data, 0); puts("\n");
  puts("static_bss  = "); putxval(static_bss,  0); puts("\n");
}

int main(void)
{
  init();
  puts("Hello World!\n");

  printval();
  puts("overwrite variables.\n");
  global_data = 0x20;
  global_bss  = 0x30;
  static_data = 0x40;
  static_bss  = 0x50;
  printval();

  while (1)
    ;

  return 0;
}
